/*
 * Copyright 2014-2017 Radian Memory Systems, Inc.  All Rights Reserved
 */
#ifndef __NVME_IOCTL_HEADER_
#define __NVME_IOCTL_HEADER_

#ifndef USE_UPSTREAM
#include "nvme_ioctl_impl.h"
#else
#include <sys/ioctl.h>
//#include <uapi/linux/nvme_ioctl.h>
#include <linux/nvme_ioctl.h>

#define XFER_TO_DEV   	0
#define XFER_FROM_DEV 	1

struct nvme_addr {
	__u64	addr;
	__u32	metadata_len;
	__u32	data_len;
};

/**
 * User passthrough definition.
 */
struct usr_io {
	struct nvme_cmd cmd;
	__u32	timeout;
	__u32	result;
	struct cq_entry comp;
#ifdef __cplusplus
	__u8    ns;
#else
	__u8	namespace;
#endif
	__u8	direction;
	__u32	status;	
	__u32	length;
	__u32	meta_length;
    __u64   addr;
    __u64   meta_addr;
};

static int __attribute__ ((unused))
ioctl2(int fd, int cmd, void* a)
{
	int rc;

	if ((__u32)cmd == (__u32)NVME_IOCTL_ADMIN_CMD) {
		struct usr_io* arg = (struct usr_io*) a;

		/* Native driver uses timeout in mSec so adjust from Radian seconds */
		arg->timeout *= 1000;
		(*(struct nvme_addr*) &arg->cmd.header.prp[0]).addr = arg->addr;
		(*(struct nvme_addr*) &arg->cmd.header.prp[0]).data_len = arg->length;
		(*(struct nvme_addr*) &arg->cmd.header.prp[0]).metadata_len = 0;

		rc = ioctl(fd, cmd, arg);

		arg->comp.param.cmdSpecific = arg->result;
		/* Separate Linux return code (negative) from NVMe return code (positive) */
		if (rc > 0) {
			arg->comp.SCT = (rc >> 8) & 0xff;
			arg->comp.SC = (rc & 0xff);
			rc = 0;
		}
	}
	else
		rc = ioctl(fd, cmd, a);

	return rc;
}

/* This alias serves for the remainder of the file... */
#define ioctl ioctl2
#endif /* USE_UPSTREAM */

#endif

